USE [Master]
GO

CREATE DATABASE [DockOfTheBay]
GO

USE [DockOfTheBay]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[Hero]') AND type in (N'U'))
DROP TABLE [dbo].[Hero]
GO

CREATE TABLE [dbo].[Hero](
	[Id] [int] IDENTITY(1,1) NOT NULL,
	[Name] [nvarchar](50) NOT NULL,
	[Brand] [nvarchar](50) NULL,
	[LastModified] [datetime] NULL,
 CONSTRAINT [PK_Hero] PRIMARY KEY CLUSTERED 
(
	[Id] ASC
))
GO

CREATE TRIGGER [dbo].[trg_iu_Hero]
ON [dbo].[Hero]
AFTER INSERT, UPDATE
AS
BEGIN
   SET NOCOUNT ON;
   
   UPDATE [dbo].[Hero]
      SET LastModified = GETDATE()
    WHERE Id IN (SELECT Id FROM inserted)
END
GO

INSERT [dbo].[Hero] ([Name], [Brand]) VALUES (N'Mega Mindy', N'Studio 100')
INSERT [dbo].[Hero] ([Name], [Brand]) VALUES (N'Geronimo Stilton', N'Edizioni Piemme')
INSERT [dbo].[Hero] ([Name], [Brand]) VALUES (N'Tinkerbell', N'Disney')
INSERT [dbo].[Hero] ([Name], [Brand]) VALUES (N'Princess Lillifee', N'Coppenrath Verlag')
INSERT [dbo].[Hero] ([Name], [Brand]) VALUES (N'Barbie', N'Mattel')
GO